<?php
namespace App\Factory;

use App\Exception;

class IntegrationFactory {
    private $connection;

    public function __construct (\Doctrine\DBAL\Connection $connection) {
        $this->connection = $connection;
    }
    
    public function disableIntegration() {
        $sql = "
            UPDATE INTEGRACAO
               SET IDHABINTE    = 'N'
             WHERE IDINTEGRACAO = 'DDI'
        ";
        
        $this->connection->executeQuery($sql);
    }

    public function getConfiguration() {
        $sql = "
            SELECT IDUFTIMEZONE, IDTOKENINTGERAL, IDSENHATOKENGERAL, IDHABINTE, IDRASTREIAENTREGA, AUTHTOKEN, AUTHTKNDTCRIAC
              FROM INTEGRACAO
             WHERE IDINTEGRACAO = 'DDI'
        ";
        
        return $this->connection->fetchAssoc($sql);
    }

    public function getMerchantConfiguration($cdFilial, $merchantId, $dlvMode) {
        $sql = "
            SELECT CDFILIAL, IDTOKEN, IDUTLENTRETERC, IDRETTXENTR 
              FROM INTEGRACAOFILI 
             WHERE CDINTEGRACAO = (SELECT CDINTEGRACAO FROM INTEGRACAO WHERE IDINTEGRACAO = :IDINTEGRACAO)
               AND IDTOKEN      = :IDTOKEN
               AND CDFILIAL     = :CDFILIAL
        ";
        
        $params = [
            ":IDINTEGRACAO" => 'DDI',
            ":IDTOKEN"      => $merchantId,
            ":CDFILIAL"     => $cdFilial
        ];
        
        return $this->connection->fetchAssoc($sql, $params);
    }
}
